unit TrkAn2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin;

type
  TTrkAnForm = class(TForm)
    Start: TButton;
    Label3: TLabel;
    Label5: TLabel;
    DATASETFILE: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditGain: TSpinEdit;
    EditDelay: TSpinEdit;
    EditRef: TSpinEdit;
    Legends: TButton;
    EditLeak: TSpinEdit;
    EditDiff: TSpinEdit;
    EditDist: TSpinEdit;
    RadioButton1: TRadioButton;
    Label6: TLabel;
    auto: TButton;
    Expand: TButton;
    TrackBar1: TTrackBar;
    procedure getmouse(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Createtrack(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure EditGainChange(Sender: TObject);
    procedure EditDelayChange(Sender: TObject);
    procedure EditLeakChange(Sender: TObject);
    procedure EditRefChange(Sender: TObject);
    procedure EditDiffChange(Sender: TObject);
    procedure EditDistChange(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure autoClick(Sender: TObject);
    procedure ExpandClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure idleloop(Sender: TObject; var Done: boolean);
  end;

var
  TrkAnForm: TTrkAnForm;

implementation
 uses analyze;

{$R *.dfm}
const lastdata = 3599;
      lastdist = 9;
      lastdiff = 2;

type disttype = array[0..lastdiff] of array[0..lastdist] of
              array[0..lastdata] of integer;

var hand: array[0..lastdata] of integer;
    dist: disttype;
    difficulty, distnum: integer;
    distitem: integer;
    hcenter, vcenter, mousex, mousey: integer;
    freq, t1, t2, reprate: int64;
    DataFile: text;
    stage: integer;
    DataFileName: string;
    distfile: file of disttype;
    newrun, running: boolean;

{$J+}
procedure showtarget(y: integer);
const oldy: integer = 0;
begin
 with TrkAnform.canvas do
  begin
   pen.color := clBlack;
   moveto(hcenter - 60, vcenter - oldy);
   lineto(hcenter - 20, vcenter - oldy);
   moveto(hcenter + 20, vcenter - oldy);
   lineto(hcenter + 60, vcenter - oldy);
   oldy := y;
   pen.color := clRed;
   moveto(hcenter - 60, vcenter - oldy);
   lineto(hcenter - 20, vcenter - oldy);
   moveto(hcenter + 20, vcenter - oldy);
   lineto(hcenter + 60, vcenter - oldy);
  end;
end;

procedure showcursor(y: integer);
const oldy: integer = 0;
begin
 with TrkAnform.canvas do
 begin
  pen.color := clBlack;
  moveto(hcenter - 20, vcenter - oldy);
  lineto(hcenter + 20, vcenter - oldy);
  oldy := y;
  pen.color := RGB(0,255,0);
  moveto(hcenter - 20, vcenter - oldy);
  lineto(hcenter + 20, vcenter - oldy);
 end;
end;

function dorun: boolean;
var i,d: integer;
begin
 with TrkAnform.canvas do
  begin
   i := abs(distitem);
   d := dist[difficulty,distnum,i];
   hand[i] := mousey;
   showtarget(d);
   showcursor(mousey);
  end;
  inc(distitem);
  dorun := distitem <= lastdata;
end;

procedure savedata;
var i: integer;
    path: string;
begin
  GetDir(0,path);
  str(difficulty, savediff);
  str(distnum,savedist);
  savename := path + '\' + Datafilename;
  rewrite(datafile);
  writeln(datafile,'Real Handle');         // handle position
  for i := 0 to lastdata do
   writeln(datafile,0.016667*i:8:6,hand[i]:8);
  writeln(datafile,'Target');  // target position
  for i := 0 to lastdata do
   writeln(datafile,0.016667*i:8:6,dist[difficulty,distnum,i]:8);
  writeln(datafile,'Real Qc');        // target minus handle
  for i := 0 to lastdata do
   writeln(datafile,0.016667*i:8:6,dist[difficulty,distnum,i] - hand[i]:8);
  writeln(datafile,'End');
  writeln(datafile,savediff);
  writeln(datafile,savedist);
  writeln(datafile,savename);
  close(datafile);
end;

procedure makedist;
var x,y,z,slow,min,max,d: double;
    i,j,k,res: integer;
begin
 randomize;
 assignfile(distfile,'Distable');
 {$I-}
 reset(distfile);
 res := IOResult;
 {$I+}
 if res = 0 then
 begin
  read(distfile,dist);
  close(distfile);
  pp := 400.0;
 end
else
 begin
  rewrite(distfile);
  slow := 10;
  for k := 0 to lastdiff do
  for j := 0 to lastdist do
  begin
   x := 0.0;
   y := 0.0;
   z := 0.0;
   difficulty := k;
   case difficulty of
    0: slow := 60.0;
    1: slow := 30.0;
    2: slow := 15.0;
   end;
  for i := 0 to lastdata do
   begin
    distnum := j;
    x := x + (3000.0*(random - 0.5) - x)/slow;
    y := y + (x - y)/slow;
    z := z + (y - z)/slow;
    dist[difficulty,distnum,i] := round(z);
   end;
  min := 0; max := 0;
  for i := 0 to lastdata do
   begin
    d := dist[difficulty,distnum,i];
    if max < d then max := d;
    if min > d then min := d;
   end;
  pp := 0.8*(max - min);
  for i := 0 to lastdata do
   begin
    d:= 2.0*((dist[difficulty,distnum,i] - min)/(max - min) - 0.5); //fraction of height
    dist[difficulty,distnum,i] := round(0.8*d*vcenter);
   end;
 end;
 write(distfile,dist);
 close(distfile);
end;
end;

procedure iterate;
begin
 case stage of
  1: if newrun then
      begin
       if not dorun then stage := 2;
      end
     else
      stage := 2;
  2: begin
      if newrun then
       savedata;
      InitAnModel;
      running := true;
      reprate := 10000;
      stage := 3;
     end;
  3: begin
      runmodel;
      plotdata;
      stage := 4;
     end;
  4: with trkanform do
      begin
       Auto.Visible := true;
       Expand.Visible := true;
       Trackbar1.Visible := true;
       EditGain.visible := true;
       EditDelay.visible := true;
       EditLeak.visible := true;
       EditRef.visible := true;
       Legends.visible := true;
       start.Visible := true;
       start.caption := 'STOP';
       Cursor := crDefault;
       stage := 5;
      end;
    5: with trkanform do
       begin
       end;
 end;
end;

procedure TTrkAnForm.getmouse(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 mousex := X; mousey := vcenter - Y;
end;

procedure TTrkAnForm.Createtrack(Sender: TObject);
 begin
 mousex := 0; mousey := 0;
 with TrkAnform do
 begin
  vcenter := (clientheight + 1) div 2;
  hcenter := (clientwidth + 1) div 2;
  editdiff.value := 1;
  editdist.value := 5;
 end;
 makedist;
 difficulty := 1;
 distnum := 5;
 distitem := -200;  {about three seconds run-in time}
 stage := 0;
 EditGain.visible := false;
 EditDelay.visible := false;
 EditLeak.visible := false;
 EditRef.visible := false;
 Legends.visible := false;
 Auto.Visible := false;
 Expand.Visible := false;
 Trackbar1.Visible := false;

 queryperformancefrequency(freq);
 queryperformancecounter(t1);
 reprate := 60;
 application.OnIdle := idleloop;
 running := false;
 newrun := false;
end;

procedure TTrkAnForm.idleloop(Sender: TObject; var Done: boolean);
begin
 done := false;
 iterate;
 repeat
  queryperformancecounter(t2);
 until (t2 - t1) >= freq/reprate;
 t1 := t2;
end;

procedure TTrkAnForm.StartClick(Sender: TObject);
begin
 if label3.visible = false then  application.terminate;
 with TrkAnform do
  begin
   DataFileName := DataSetfile.text;
   if DataFileName = '' then DataFileName := 'NoName';
   DataFileName := DataFileName + '.dat';
   AnalyzeDataName := DataFileName;
   assignfile(datafile,DataFileName);
   difficulty := strtointdef(editdiff.text,1);
   if difficulty < 0 then difficulty := 0;
   if difficulty > lastdiff then difficulty := lastdiff;
   distnum := strtointdef(editdist.text,5);
   if distnum > lastdist then distnum := lastdist;
   if distnum < 0 then distnum := 0;
   DataSetfile.visible := false;
   Label1.visible := false;
   Label2.Visible := false;
   editdiff.Visible := false;
   editdist.Visible := false;
   Label3.visible := false;
   Label5.visible := false;
   Label6.visible := false;
   cursor := crNone;
   start.Visible := false;
   Label6.visible := false;
   RadioButton1.visible := false;
  end;
  reprate := 60;
  expanded := false;
  stage := 1;    { start iterations}
end;

procedure TTrkAnForm.EditGainChange(Sender: TObject);
begin
 GainSet := EditGain.value;
 runmodel;
 plotdata;
end;

procedure TTrkAnForm.EditDelayChange(Sender: TObject);
begin
 DelaySet := EditDelay.value;
 runmodel;
 plotdata;
end;

procedure TTrkAnForm.EditLeakChange(Sender: TObject);
begin
 LeakSet := EditLeak.value;
 runmodel;
 plotdata;
end;

procedure TTrkAnForm.EditRefChange(Sender: TObject);
begin
 RefSet := EditRef.value;
 runmodel;
 plotdata;
end;

procedure TTrkAnForm.EditDiffChange(Sender: TObject);
begin
 Difficulty := EditDiff.Value;
end;

procedure TTrkAnForm.EditDistChange(Sender: TObject);
begin
 Distnum := EditDist.value;
end;

procedure TTrkAnForm.RadioButton1Click(Sender: TObject);
begin
 newrun := RadioButton1.checked;
end;

procedure TTrkAnForm.autoClick(Sender: TObject);
begin
 autofit;
 plotdata;
end;

procedure TTrkAnForm.ExpandClick(Sender: TObject);
begin
 expanded := not expanded;
 if expanded then expand.caption := 'Narrow'
  else expand.caption := 'Expand';
 if not expanded then startdata := 0;
 plotdata;
end;

procedure TTrkAnForm.TrackBar1Change(Sender: TObject);
begin
 if expanded then
  begin
   startdata := trackbar1.position;
   runmodel;
   plotdata;
  end
 else startdata := 0;
end;

end.
